from logging.config import fileConfig

from alembic import context
from server.config import get_app_config
from server.infra.db.db_mapper import mapper_registry
from server.modules.attachments.repository.models import *
from server.modules.descriptions.repository.models import *
from server.modules.rate.repository.models import *
from server.modules.recognizer.repository.models import *
from sqlalchemy import engine_from_config, pool
from sqlalchemy.ext.declarative import declarative_base

# this is the Alembic Config object, which provides
# access to the values within the .ini file in use.
config = context.config
Base = declarative_base()
target_metadata = Base.metadata

for table_name, table in mapper_registry.metadata.tables.items():
    target_metadata._add_table(table_name, table.schema, table)

# Interpret the config file for Python logging.
# This line sets up loggers basically.
if config.config_file_name is not None:
    fileConfig(config.config_file_name)


def run_migrations_offline() -> None:
    """Run migrations in 'offline' mode.

    This configures the context with just a URL
    and not an Engine, though an Engine is acceptable
    here as well.  By skipping the Engine creation
    we don't even need a DBAPI to be available.

    Calls to context.execute() here emit the given string to the
    script output.

    """
    url = "{}?options=-c search_path={}".format(
        str(get_app_config().db_uri).replace("+asyncpg", ""),
        get_app_config().db_search_path,
    )
    context.configure(
        url=url,
        target_metadata=target_metadata,
        literal_binds=True,
        dialect_opts={"paramstyle": "named"},
    )

    with context.begin_transaction():
        context.run_migrations()


def run_migrations_online() -> None:
    """Run migrations in 'online' mode.

    In this scenario we need to create an Engine
    and associate a connection with the context.

    """
    alemb_cnf = config.get_section(config.config_ini_section, {})
    if not alemb_cnf["sqlalchemy.url"] or alemb_cnf["sqlalchemy.url"] == "driver://user:pass@localhost/dbname":
        alemb_cnf["sqlalchemy.url"] = "{}?options=-c search_path={}".format(
            str(get_app_config().db_uri).replace("+asyncpg", ""),
            get_app_config().db_search_path,
        )
    connectable = engine_from_config(
        alemb_cnf,
        prefix="sqlalchemy.",
        poolclass=pool.NullPool,
    )

    with connectable.connect() as connection:
        context.configure(
            connection=connection,
            target_metadata=target_metadata,
        )

        with context.begin_transaction():
            context.run_migrations()


if context.is_offline_mode():
    run_migrations_offline()
else:
    run_migrations_online()
